// SelectBox.cpp : implementation file
//

#include "stdafx.h"
#include "OkMfc.h"
#include "SelectBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#ifdef _X64
#include "okapi64.h"
#else
#include "okapi32.h"
#endif

extern	MLONG 		iCurrUsedNo;//	
extern	HANDLE		hBoard;
extern	HWND		hWnd;
extern	BYTE		bActive;

static	int 	bFind=0, bNetFind=-1;

/////////////////////////////////////////////////////////////////////////////
// CSelectBox dialog


CSelectBox::CSelectBox(CWnd* pParent /*=NULL*/)
	: CDialog(CSelectBox::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectBox)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSelectBox::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectBox)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelectBox, CDialog)
	//{{AFX_MSG_MAP(CSelectBox)
	ON_CBN_SELCHANGE(IDC_BOARDLIST, OnSelchangeBoardlist)
	ON_BN_CLICKED(IDC_REFINDLIST, OnRefindlist)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CSelectBox::OnBnClickedOk)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectBox message handlers

BOOL CSelectBox::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	int			i,total;
	OKDEVTYPE	*lpBoardInfo;
	static	int	iVirtCode=0;
	static		char szVirtName[30];
	char		string[120];

	//total=okGetSlotBoard(&lpBoardInfo);
	total = okGetImageDevice(&lpBoardInfo, (MLONG)&bFind);

	if(bNetFind == -1) //first time
		bNetFind = bFind&1;

	if(bNetFind == 1) 
		CheckDlgButton(IDC_NETDEVICE,BST_CHECKED);
	else
		CheckDlgButton(IDC_NETDEVICE,BST_UNCHECKED);

	bFind=0;

	if( !iVirtCode && (iCurrUsedNo>=total) ) { //one virtual card 
		iVirtCode=okGetTypeCode(hBoard, szVirtName);
	}

    SetDlgItemInt(IDC_TOTALBOARD,total,FALSE);
	for(i=0;i<total;i++) {
		sprintf(string," No.%d :  Type code=%d,  Name=%s ",
			i,lpBoardInfo[i].iBoardTypeCode,lpBoardInfo[i].szBoardName);
		SendDlgItemMessage(IDC_BOARDLIST,CB_ADDSTRING,0,(LPARAM)string); 
	}
	if(iVirtCode) {
		sprintf(string," Virtual:  Type code=%d,  Name=%s ",iVirtCode,szVirtName);
		SendDlgItemMessage(IDC_BOARDLIST,CB_ADDSTRING,0,(LPARAM)string); 
	}
	if(iCurrUsedNo<0)
		iCurrUsedNo=0;
	SendDlgItemMessage(IDC_BOARDLIST,CB_SETCURSEL,iCurrUsedNo,0);
	SetDlgItemInt(IDC_CURRUSED,iCurrUsedNo,0);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSelectBox::OnOK() 
{
	if(IsDlgButtonChecked(IDC_NETDEVICE))
		bNetFind=1;
	else
		bNetFind=0;

	CDialog::OnOK();
}

void CSelectBox::OnSelchangeBoardlist() 
{
	// TODO: Add your control notification handler code here
	iCurrUsedNo=SendDlgItemMessage(IDC_BOARDLIST,CB_GETCURSEL,0,0);
	if(iCurrUsedNo==-1)
		iCurrUsedNo=0;
	SetDlgItemInt(IDC_CURRUSED,iCurrUsedNo,0);
}

void CSelectBox::OnRefindlist() 
{
	INT32	i, count;

	count = SendDlgItemMessage(IDC_BOARDLIST, CB_GETCOUNT, 0, 0); 
	for (i=count; i>0; i--)
		SendDlgItemMessage(IDC_BOARDLIST, CB_DELETESTRING, i-1, 0); 

	bFind=1;
	if(IsDlgButtonChecked(IDC_NETDEVICE)) {
		bFind |=2;
		bNetFind=1;
	}
	else
		bNetFind=0;

	OnInitDialog();
}

void CSelectBox::OnBnClickedOk()
{
	// TODO: ڴӿؼ֪ͨ
	OnOK();
}
